// Generated by delombok at Mon Oct 04 13:52:54 EDT 2021
package gov.cms.fiss.pricers.ipps.api;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

public class CbsaData {
  @Schema(description = "Wage index of CBSA Data", example = "0.0")
  @NotNull
  private BigDecimal wageIndex = BigDecimal.ZERO;
  @Schema(description = "Standard amount of location of CBSA Data", example = "00000")
  @Size(max = 5)
  private String standardAmountLocation;
  @Schema(description = "Special payment indicator of CBSA Data", example = " ")
  @JsonProperty
  @Size(max = 1)
  private String specialPaymentIndicator;
  @Schema(description = "Hospital quality indicator of CBSA Data", example = "1")
  @Size(max = 1)
  private String hospitalQualityIndicator;
  @Schema(description = "Geolocation of CBSA Data", example = "33340")
  @Pattern(regexp = "[0-9 ]*")
  @Size(max = 5)
  private String geolocation;
  @Schema(description = "Reclassified location of CBSA Data", example = "00000")
  @Size(max = 5)
  private String reclassifiedLocation;
  @Schema(description = "Supplemental wage index indicator of CBSA Data", example = "1")
  @Size(max = 1)
  private String supplementalWageIndexIndicator;
  @Schema(description = "Supplemental wage index of CBSA Data", example = "0.0")
  private BigDecimal supplementalWageIndex = BigDecimal.ZERO;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CbsaData(final BigDecimal wageIndex, final String standardAmountLocation, final String specialPaymentIndicator, final String hospitalQualityIndicator, final String geolocation, final String reclassifiedLocation, final String supplementalWageIndexIndicator, final BigDecimal supplementalWageIndex) {
    this.wageIndex = wageIndex;
    this.standardAmountLocation = standardAmountLocation;
    this.specialPaymentIndicator = specialPaymentIndicator;
    this.hospitalQualityIndicator = hospitalQualityIndicator;
    this.geolocation = geolocation;
    this.reclassifiedLocation = reclassifiedLocation;
    this.supplementalWageIndexIndicator = supplementalWageIndexIndicator;
    this.supplementalWageIndex = supplementalWageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getWageIndex() {
    return this.wageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getStandardAmountLocation() {
    return this.standardAmountLocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSpecialPaymentIndicator() {
    return this.specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getHospitalQualityIndicator() {
    return this.hospitalQualityIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getGeolocation() {
    return this.geolocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getReclassifiedLocation() {
    return this.reclassifiedLocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSupplementalWageIndexIndicator() {
    return this.supplementalWageIndexIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getSupplementalWageIndex() {
    return this.supplementalWageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setWageIndex(final BigDecimal wageIndex) {
    this.wageIndex = wageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setStandardAmountLocation(final String standardAmountLocation) {
    this.standardAmountLocation = standardAmountLocation;
  }

  @JsonProperty
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSpecialPaymentIndicator(final String specialPaymentIndicator) {
    this.specialPaymentIndicator = specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setHospitalQualityIndicator(final String hospitalQualityIndicator) {
    this.hospitalQualityIndicator = hospitalQualityIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setGeolocation(final String geolocation) {
    this.geolocation = geolocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setReclassifiedLocation(final String reclassifiedLocation) {
    this.reclassifiedLocation = reclassifiedLocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSupplementalWageIndexIndicator(final String supplementalWageIndexIndicator) {
    this.supplementalWageIndexIndicator = supplementalWageIndexIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSupplementalWageIndex(final BigDecimal supplementalWageIndex) {
    this.supplementalWageIndex = supplementalWageIndex;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof CbsaData)) return false;
    final CbsaData other = (CbsaData) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$wageIndex = this.getWageIndex();
    final java.lang.Object other$wageIndex = other.getWageIndex();
    if (this$wageIndex == null ? other$wageIndex != null : !this$wageIndex.equals(other$wageIndex)) return false;
    final java.lang.Object this$standardAmountLocation = this.getStandardAmountLocation();
    final java.lang.Object other$standardAmountLocation = other.getStandardAmountLocation();
    if (this$standardAmountLocation == null ? other$standardAmountLocation != null : !this$standardAmountLocation.equals(other$standardAmountLocation)) return false;
    final java.lang.Object this$specialPaymentIndicator = this.getSpecialPaymentIndicator();
    final java.lang.Object other$specialPaymentIndicator = other.getSpecialPaymentIndicator();
    if (this$specialPaymentIndicator == null ? other$specialPaymentIndicator != null : !this$specialPaymentIndicator.equals(other$specialPaymentIndicator)) return false;
    final java.lang.Object this$hospitalQualityIndicator = this.getHospitalQualityIndicator();
    final java.lang.Object other$hospitalQualityIndicator = other.getHospitalQualityIndicator();
    if (this$hospitalQualityIndicator == null ? other$hospitalQualityIndicator != null : !this$hospitalQualityIndicator.equals(other$hospitalQualityIndicator)) return false;
    final java.lang.Object this$geolocation = this.getGeolocation();
    final java.lang.Object other$geolocation = other.getGeolocation();
    if (this$geolocation == null ? other$geolocation != null : !this$geolocation.equals(other$geolocation)) return false;
    final java.lang.Object this$reclassifiedLocation = this.getReclassifiedLocation();
    final java.lang.Object other$reclassifiedLocation = other.getReclassifiedLocation();
    if (this$reclassifiedLocation == null ? other$reclassifiedLocation != null : !this$reclassifiedLocation.equals(other$reclassifiedLocation)) return false;
    final java.lang.Object this$supplementalWageIndexIndicator = this.getSupplementalWageIndexIndicator();
    final java.lang.Object other$supplementalWageIndexIndicator = other.getSupplementalWageIndexIndicator();
    if (this$supplementalWageIndexIndicator == null ? other$supplementalWageIndexIndicator != null : !this$supplementalWageIndexIndicator.equals(other$supplementalWageIndexIndicator)) return false;
    final java.lang.Object this$supplementalWageIndex = this.getSupplementalWageIndex();
    final java.lang.Object other$supplementalWageIndex = other.getSupplementalWageIndex();
    if (this$supplementalWageIndex == null ? other$supplementalWageIndex != null : !this$supplementalWageIndex.equals(other$supplementalWageIndex)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof CbsaData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $wageIndex = this.getWageIndex();
    result = result * PRIME + ($wageIndex == null ? 43 : $wageIndex.hashCode());
    final java.lang.Object $standardAmountLocation = this.getStandardAmountLocation();
    result = result * PRIME + ($standardAmountLocation == null ? 43 : $standardAmountLocation.hashCode());
    final java.lang.Object $specialPaymentIndicator = this.getSpecialPaymentIndicator();
    result = result * PRIME + ($specialPaymentIndicator == null ? 43 : $specialPaymentIndicator.hashCode());
    final java.lang.Object $hospitalQualityIndicator = this.getHospitalQualityIndicator();
    result = result * PRIME + ($hospitalQualityIndicator == null ? 43 : $hospitalQualityIndicator.hashCode());
    final java.lang.Object $geolocation = this.getGeolocation();
    result = result * PRIME + ($geolocation == null ? 43 : $geolocation.hashCode());
    final java.lang.Object $reclassifiedLocation = this.getReclassifiedLocation();
    result = result * PRIME + ($reclassifiedLocation == null ? 43 : $reclassifiedLocation.hashCode());
    final java.lang.Object $supplementalWageIndexIndicator = this.getSupplementalWageIndexIndicator();
    result = result * PRIME + ($supplementalWageIndexIndicator == null ? 43 : $supplementalWageIndexIndicator.hashCode());
    final java.lang.Object $supplementalWageIndex = this.getSupplementalWageIndex();
    result = result * PRIME + ($supplementalWageIndex == null ? 43 : $supplementalWageIndex.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "CbsaData(wageIndex=" + this.getWageIndex() + ", standardAmountLocation=" + this.getStandardAmountLocation() + ", specialPaymentIndicator=" + this.getSpecialPaymentIndicator() + ", hospitalQualityIndicator=" + this.getHospitalQualityIndicator() + ", geolocation=" + this.getGeolocation() + ", reclassifiedLocation=" + this.getReclassifiedLocation() + ", supplementalWageIndexIndicator=" + this.getSupplementalWageIndexIndicator() + ", supplementalWageIndex=" + this.getSupplementalWageIndex() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CbsaData() {
  }
}
