package gov.cms.fiss.pricers.ipps.core.rules.calculate_payment.tech_addons.technology;

import gov.cms.fiss.pricers.ipps.core.IppsPricerContext;
import gov.cms.fiss.pricers.ipps.core.tables.ClaimCodeType;
import gov.cms.fiss.pricers.ipps.core.tables.DataTables;

/**
 * Applies add-on costs for PRCFC if the technology was indicated in the claim.
 *
 * @since 2022
 */
public class CalculatePrcfcAddOnCost extends CalculateTechnologyAddOnCost {

  private static final String TECHNOLOGY_NAME = "PRCFC";

  @Override
  public void priceClaim(IppsPricerContext calculationContext) {
    final DataTables dataTables = calculationContext.getDataTables();

    if (dataTables.codesMatch(
            TECHNOLOGY_NAME,
            ClaimCodeType.PROC,
            calculationContext.getBillingRecord().getProcedureCodes())
        && dataTables.codesMatch(
            TECHNOLOGY_NAME,
            ClaimCodeType.DIAG,
            calculationContext.getBillingRecord().getDiagnosisCodes())) {
      aggregateNewTechCost(calculationContext, dataTables.getNewTechnologyAmount(TECHNOLOGY_NAME));
    }
  }
}
